%{!?_licensedir:%global license %doc}

%global engine_etc /etc/ovirt-engine
%global engine_data %{_datadir}/ovirt-engine
%global jboss_deployments %{_javadir}/%{name}/jboss-conf/deployments
%global _eap7_root /opt/rh/eap7/root
%global _optaplanner %{_javadir}
%global log_config_file log4j.properties

# The version macro to be redefined by Jenkins build when needed
%define project_version 0.14
%{!?_version: %define _version %{project_version}}

Name:		ovirt-optimizer
Version:	%{_version}
Release:	2%{?dist}
Summary:	Cluster balance optimization service for RHEVM
Group:		Virtualization/Management
License:	ASL 2.0
URL:		http://www.ovirt.org

Source0: ovirt-optimizer-0.14-scm-sources.zip
Source1: ovirt-optimizer-0.14-patches.zip
Source2: maven-metadata.xml
Source3: maven-metadata.xml.md5
Source4: maven-metadata.xml.sha1
Source5: ovirt-optimizer-core-0.14-sources.jar.md5
Source6: ovirt-optimizer-core-0.14.jar.md5
Source7: ovirt-optimizer-core-0.14.pom
Source8: ovirt-optimizer-core-0.14.pom.sha1
Source9: ovirt-optimizer-core-0.14.jar.sha1
Source10: ovirt-optimizer-core-0.14-sources.jar.sha1
Source11: ovirt-optimizer-core-0.14.pom.md5
Source12: ovirt-optimizer-core-0.14.jar
Source13: ovirt-optimizer-core-0.14-sources.jar
Source14: maven-metadata.xml
Source15: maven-metadata.xml.md5
Source16: maven-metadata.xml.sha1
Source17: ovirt-optimizer-0.14.pom.md5
Source18: ovirt-optimizer-0.14.pom.sha1
Source19: ovirt-optimizer-0.14.pom
Source20: maven-metadata.xml
Source21: maven-metadata.xml.md5
Source22: maven-metadata.xml.sha1
Source23: ovirt-optimizer-jboss7-0.14.pom.md5
Source24: ovirt-optimizer-jboss7-0.14-sources.jar
Source25: ovirt-optimizer-jboss7-0.14-sources.jar.sha1
Source26: ovirt-optimizer-jboss7-0.14.pom
Source27: ovirt-optimizer-jboss7-0.14.war.md5
Source28: ovirt-optimizer-jboss7-0.14.pom.sha1
Source29: ovirt-optimizer-jboss7-0.14.war.sha1
Source30: ovirt-optimizer-jboss7-0.14-sources.jar.md5
Source31: ovirt-optimizer-jboss7-0.14.war
Source32: maven-metadata.xml
Source33: maven-metadata.xml.md5
Source34: maven-metadata.xml.sha1
Source35: ovirt-optimizer-jetty-0.14.pom.md5
Source36: ovirt-optimizer-jetty-0.14-sources.jar
Source37: ovirt-optimizer-jetty-0.14.pom
Source38: ovirt-optimizer-jetty-0.14-sources.jar.md5
Source39: ovirt-optimizer-jetty-0.14.war.sha1
Source40: ovirt-optimizer-jetty-0.14.pom.sha1
Source41: ovirt-optimizer-jetty-0.14-sources.jar.sha1
Source42: ovirt-optimizer-jetty-0.14.war.md5
Source43: ovirt-optimizer-jetty-0.14.war

BuildArch:	noarch

BuildRequires:	unzip
BuildRequires:  symlinks
BuildRequires:  java-1.8.0-openjdk-devel

Requires:	java >= 1:1.8.0

Requires:       curl
Requires:       unzip

Requires:       mvn(org.apache.httpcomponents:httpclient)
Requires:       mvn(org.apache.httpcomponents:httpcore)
Requires:       mvn(commons-io:commons-io)
Requires:       eap7-guava

Requires:       mvn(org.slf4j:slf4j-api)

Requires:       ovirt-engine-sdk-java >= 3.6
Requires:       mvn(org.ovirt.engine.api:sdk) >= 4.0
Requires:       optaplanner >= 6.4

%description
%{name} service collects data from the oVirt engine and proposes
Vm to host assignments to utilize cluster resources better.

%package ui
Summary:        UI for displaying results in oVirt webadmin
Requires:	ovirt-engine-webadmin-portal >= 4.0

%description ui
This subpackage adds an UI plugin to the oVirt webadmin portal.
This plugin then adds a Tab to the cluster display and presents
the assingment recommendations to the sysadmin there.

%package jboss
Summary:       Integration of the optimization service to Jboss 7.
Provides:      %{name}-wildfly = %{version}
Requires:      %{name} = %{version}
Requires:      %{name}-dependencies = %{version}

Requires(post): %{name} = %{version}
Requires(post): %{name}-dependencies = %{version}
Requires(post): findutils

Requires:      eap7-wildfly >= 7.0

Requires(post): systemd
Requires(preun): systemd
Requires(postun): systemd
BuildRequires: systemd


%description jboss
This subpackage deploys the optimizer service to the standard Jboss 7
application server.


%package dependencies
Summary:       Libraries not currently provided by the system, but necessary for the project.
Requires:      %{name} = %{version}

Requires:      mvn(commons-beanutils:commons-beanutils)
Requires:      mvn(commons-logging:commons-logging)

Requires:      mvn(log4j:log4j)
Requires:      mvn(org.slf4j:slf4j-log4j12)

%description dependencies
This subpackage bundles libraries that are not provided in the form of RPMs, but are necessary
for the project to work. The goal is to drop this subpackage once the dependencies are available.


%prep

%build
# recreate maven target structure from MEAD artifacts
  echo ovirt-optimizer-0.14-scm-sources.zip
  namewithver=$(basename ovirt-optimizer-0.14-scm-sources)
  name=ovirt-optimizer
    unzip -o %{SOURCE0}
  echo ovirt-optimizer-0.14-patches.zip
  namewithver=$(basename ovirt-optimizer-0.14-patches)
  name=ovirt-optimizer
    unzip -o %{SOURCE1}
  echo maven-metadata.xml
  namewithver=$(basename maven-metadata)
  name=maven-metadata
  echo maven-metadata.xml.md5
  namewithver=$(basename maven-metadata.xml)
  name=maven-metadata.xml
  echo maven-metadata.xml.sha1
  namewithver=$(basename maven-metadata.xml.)
  name=maven-metadata.xml.
  echo ovirt-optimizer-core-0.14-sources.jar.md5
  namewithver=$(basename ovirt-optimizer-core-0.14-sources.jar)
  name=ovirt-optimizer-core
  echo ovirt-optimizer-core-0.14.jar.md5
  namewithver=$(basename ovirt-optimizer-core-0.14.jar)
  name=ovirt-optimizer-core-0.14.jar
  echo ovirt-optimizer-core-0.14.pom
  namewithver=$(basename ovirt-optimizer-core-0.14)
  name=ovirt-optimizer-core
  echo ovirt-optimizer-core-0.14.pom.sha1
  namewithver=$(basename ovirt-optimizer-core-0.14.pom.)
  name=ovirt-optimizer-core-0.14.pom.
  echo ovirt-optimizer-core-0.14.jar.sha1
  namewithver=$(basename ovirt-optimizer-core-0.14.jar.)
  name=ovirt-optimizer-core-0.14.jar.
  echo ovirt-optimizer-core-0.14-sources.jar.sha1
  namewithver=$(basename ovirt-optimizer-core-0.14-sources.jar.)
  name=ovirt-optimizer-core
  echo ovirt-optimizer-core-0.14.pom.md5
  namewithver=$(basename ovirt-optimizer-core-0.14.pom)
  name=ovirt-optimizer-core-0.14.pom
  echo ovirt-optimizer-core-0.14.jar
  namewithver=$(basename ovirt-optimizer-core-0.14)
  name=ovirt-optimizer-core
    mkdir -p $name/target/$name
    cp %{SOURCE12} $name/target/$name.jar
  echo ovirt-optimizer-core-0.14-sources.jar
  namewithver=$(basename ovirt-optimizer-core-0.14-sources)
  name=ovirt-optimizer-core
    echo "Skip sources.."
  echo maven-metadata.xml
  namewithver=$(basename maven-metadata)
  name=maven-metadata
  echo maven-metadata.xml.md5
  namewithver=$(basename maven-metadata.xml)
  name=maven-metadata.xml
  echo maven-metadata.xml.sha1
  namewithver=$(basename maven-metadata.xml.)
  name=maven-metadata.xml.
  echo ovirt-optimizer-0.14.pom.md5
  namewithver=$(basename ovirt-optimizer-0.14.pom)
  name=ovirt-optimizer-0.14.pom
  echo ovirt-optimizer-0.14.pom.sha1
  namewithver=$(basename ovirt-optimizer-0.14.pom.)
  name=ovirt-optimizer-0.14.pom.
  echo ovirt-optimizer-0.14.pom
  namewithver=$(basename ovirt-optimizer-0.14)
  name=ovirt-optimizer
  echo maven-metadata.xml
  namewithver=$(basename maven-metadata)
  name=maven-metadata
  echo maven-metadata.xml.md5
  namewithver=$(basename maven-metadata.xml)
  name=maven-metadata.xml
  echo maven-metadata.xml.sha1
  namewithver=$(basename maven-metadata.xml.)
  name=maven-metadata.xml.
  echo ovirt-optimizer-jboss7-0.14.pom.md5
  namewithver=$(basename ovirt-optimizer-jboss7-0.14.pom)
  name=ovirt-optimizer-jboss7-0.14.pom
  echo ovirt-optimizer-jboss7-0.14-sources.jar
  namewithver=$(basename ovirt-optimizer-jboss7-0.14-sources)
  name=ovirt-optimizer-jboss7
    echo "Skip sources.."
  echo ovirt-optimizer-jboss7-0.14-sources.jar.sha1
  namewithver=$(basename ovirt-optimizer-jboss7-0.14-sources.jar.)
  name=ovirt-optimizer-jboss7
  echo ovirt-optimizer-jboss7-0.14.pom
  namewithver=$(basename ovirt-optimizer-jboss7-0.14)
  name=ovirt-optimizer-jboss7
  echo ovirt-optimizer-jboss7-0.14.war.md5
  namewithver=$(basename ovirt-optimizer-jboss7-0.14.war)
  name=ovirt-optimizer-jboss7-0.14.war
  echo ovirt-optimizer-jboss7-0.14.pom.sha1
  namewithver=$(basename ovirt-optimizer-jboss7-0.14.pom.)
  name=ovirt-optimizer-jboss7-0.14.pom.
  echo ovirt-optimizer-jboss7-0.14.war.sha1
  namewithver=$(basename ovirt-optimizer-jboss7-0.14.war.)
  name=ovirt-optimizer-jboss7-0.14.war.
  echo ovirt-optimizer-jboss7-0.14-sources.jar.md5
  namewithver=$(basename ovirt-optimizer-jboss7-0.14-sources.jar)
  name=ovirt-optimizer-jboss7
  echo ovirt-optimizer-jboss7-0.14.war
  namewithver=$(basename ovirt-optimizer-jboss7-0.14)
  name=ovirt-optimizer-jboss7
    mkdir -p $name/target/$name
    cp %{SOURCE31} $name/target
    pushd $name/target/$name
    unzip -o ../*.war
    popd
  echo maven-metadata.xml
  namewithver=$(basename maven-metadata)
  name=maven-metadata
  echo maven-metadata.xml.md5
  namewithver=$(basename maven-metadata.xml)
  name=maven-metadata.xml
  echo maven-metadata.xml.sha1
  namewithver=$(basename maven-metadata.xml.)
  name=maven-metadata.xml.
  echo ovirt-optimizer-jetty-0.14.pom.md5
  namewithver=$(basename ovirt-optimizer-jetty-0.14.pom)
  name=ovirt-optimizer-jetty-0.14.pom
  echo ovirt-optimizer-jetty-0.14-sources.jar
  namewithver=$(basename ovirt-optimizer-jetty-0.14-sources)
  name=ovirt-optimizer-jetty
    echo "Skip sources.."
  echo ovirt-optimizer-jetty-0.14.pom
  namewithver=$(basename ovirt-optimizer-jetty-0.14)
  name=ovirt-optimizer-jetty
  echo ovirt-optimizer-jetty-0.14-sources.jar.md5
  namewithver=$(basename ovirt-optimizer-jetty-0.14-sources.jar)
  name=ovirt-optimizer-jetty
  echo ovirt-optimizer-jetty-0.14.war.sha1
  namewithver=$(basename ovirt-optimizer-jetty-0.14.war.)
  name=ovirt-optimizer-jetty-0.14.war.
  echo ovirt-optimizer-jetty-0.14.pom.sha1
  namewithver=$(basename ovirt-optimizer-jetty-0.14.pom.)
  name=ovirt-optimizer-jetty-0.14.pom.
  echo ovirt-optimizer-jetty-0.14-sources.jar.sha1
  namewithver=$(basename ovirt-optimizer-jetty-0.14-sources.jar.)
  name=ovirt-optimizer-jetty
  echo ovirt-optimizer-jetty-0.14.war.md5
  namewithver=$(basename ovirt-optimizer-jetty-0.14.war)
  name=ovirt-optimizer-jetty-0.14.war
  echo ovirt-optimizer-jetty-0.14.war
  namewithver=$(basename ovirt-optimizer-jetty-0.14)
  name=ovirt-optimizer-jetty
    mkdir -p $name/target/$name
    cp %{SOURCE43} $name/target
    pushd $name/target/$name
    unzip -o ../*.war
    popd

# Apply patches
pushd ovirt-optimizer
for p in *.patch; do
  patch -Np1 -i $p
done
popd

# Copy documentation
mv ovirt-optimizer/dist ovirt-optimizer/README* ovirt-optimizer/COPYING .

cat >COPYING.csv <<EOF
"Required by","Name","Version","License","Summary","URL","Repository"
"ovirt-optimizer(ASL 2.0)", "quartz", "2.2.0", "ASL 2.0", "Timer and scheduling library", "http://quartz-scheduler.org/", "ovirt-optimizer-dependencies"
EOF

%install

# Copy core jars to the proper place
install -dm 755 %{buildroot}%{_javadir}/%{name}
install -dm 755 %{buildroot}%{_javadir}/%{name}/bundled
mv ovirt-optimizer-core/target/ovirt-optimizer-core.jar %{buildroot}%{_javadir}/%{name}


# Install the start script
install -dm 755 %{buildroot}/usr/bin/
mv dist/bin/ovirt-optimizer-jboss %{buildroot}/usr/bin/

install -dm 755 %{buildroot}%{_unitdir}
mv dist/initscript/ovirt-optimizer-jboss.service %{buildroot}%{_unitdir}

# Create the JBoss config directory structure for standalone run
cp -ar dist/jboss-conf %{buildroot}%{_javadir}/%{name}

# Create the log file directory
mkdir -p %{buildroot}/var/log/%{name}/jboss
ln -sf /var/log/%{name}/jboss %{buildroot}%{_javadir}/%{name}/jboss-conf/log

pushd ovirt-optimizer-jboss7

# Remove the bundled jars by moving them elsewhere and then
# copying only the needed files back. The rest is provided
# by this package's dependencies.
mkdir target/lib
mv target/ovirt-optimizer-jboss7/WEB-INF/lib/* target/lib

JBOSS_SYMLINK="%{_javadir}/%{name}/%{name}-core.jar
%{_javadir}/ovirt-engine-sdk-java/ovirt-engine-sdk-java.jar
%{_javadir}/java-ovirt-engine-sdk4/sdk.jar
%{_optaplanner}/optaplanner-annotations.jar
%{_optaplanner}/optaplanner-antlr-runtime.jar
%{_optaplanner}/optaplanner-commons-codec.jar
%{_optaplanner}/optaplanner-commons-math3.jar
%{_optaplanner}/optaplanner-commons-lang3.jar
%{_optaplanner}/optaplanner-core.jar
%{_optaplanner}/optaplanner-drools-compiler.jar
%{_optaplanner}/optaplanner-drools-core.jar
%{_optaplanner}/optaplanner-ecj.jar
%{_optaplanner}/optaplanner-javassist.jar
%{_optaplanner}/optaplanner-kie-api.jar
%{_optaplanner}/optaplanner-kie-internal.jar
%{_optaplanner}/optaplanner-mvel2.jar
%{_optaplanner}/optaplanner-protobuf-java.jar
%{_optaplanner}/optaplanner-reflections.jar
%{_optaplanner}/optaplanner-xmlpull.jar
%{_optaplanner}/optaplanner-xpp3_min.jar
%{_optaplanner}/optaplanner-xstream.jar
%{_javadir}/apache-commons-beanutils.jar
%{_javadir}/commons-io.jar
%{_javadir}/commons-logging.jar
%{_javadir}/log4j.jar
%{_javadir}/httpcomponents/httpclient.jar
%{_javadir}/httpcomponents/httpcore.jar
%{_javadir}/slf4j/slf4j-api.jar
%{_javadir}/slf4j/slf4j-log4j12.jar
%{_eap7_root}%{_javadir}/guava.jar"

JBOSS_BUNDLE="target/lib/quartz-*"

# Install the exploded Jboss war to javadir
cp -ar target/ovirt-optimizer-jboss7 %{buildroot}%{_javadir}/%{name}/jboss.war

# Move config file to etc and symlink it to the right place
install -dm 755 %{buildroot}/etc/%{name}
mv %{buildroot}%{_javadir}/%{name}/jboss.war/WEB-INF/classes/%{log_config_file} %{buildroot}/etc/%{name}/jboss-%{log_config_file}
ln -sf /etc/%{name}/jboss-%{log_config_file} %{buildroot}%{_javadir}/%{name}/jboss.war/WEB-INF/classes/%{log_config_file}

# Symlink libs to %{buildroot}%{_javadir}/%{name}/jboss/WEB-INF/lib
echo "$JBOSS_SYMLINK" | xargs -d \\n -I@ sh -c "ln -s -t %{buildroot}%{_javadir}/%{name}/jboss.war/WEB-INF/lib @"

# Copy bundled libs to %{buildroot}%{_javadir}/%{name}/bundled
echo "$JBOSS_BUNDLE" | xargs -d \\n -I@ sh -c "cp -t %{buildroot}%{_javadir}/%{name}/bundled @"

# Symlink the bundled libs to %{buildroot}%{_javadir}/%{name}/jboss/WEB-INF/lib
cp -Rs %{buildroot}%{_javadir}/%{name}/bundled/* %{buildroot}%{_javadir}/%{name}/jboss.war/WEB-INF/lib
symlinks -rc %{buildroot}%{_javadir}/%{name}/jboss.war/WEB-INF/lib

# Symlink it to Jboss war directory and touch the deploy marker
install -dm 755 %{buildroot}%{jboss_deployments}
ln -sf %{_javadir}/%{name}/jboss.war %{buildroot}%{jboss_deployments}/%{name}.war
touch %{buildroot}%{jboss_deployments}/%{name}.war.dodeploy

popd



# Copy the setup script to documentation
install -dm 755 %{buildroot}%{_docdir}/%{name}-%{version}


# Install the UI plugin to the oVirt webadmin
install -dm 755 %{buildroot}%{engine_data}/ui-plugins
install -dm 755 %{buildroot}%{engine_etc}/ui-plugins
install -dm 755 %{buildroot}%{engine_data}/ui-plugins/ovirt-optimizer-resources
install dist/ovirt-optimizer-uiplugin/*.json %{buildroot}%{engine_data}/ui-plugins/
install dist/ovirt-optimizer-uiplugin/ovirt-optimizer-resources/* %{buildroot}%{engine_data}/ui-plugins/ovirt-optimizer-resources
install dist/etc/*.json %{buildroot}%{engine_etc}/ui-plugins/

# Install config file
install -dm 755 %{buildroot}/etc/%{name}
install dist/etc/*.properties %{buildroot}/etc/%{name}

%files
%defattr(644, root, root, 755)
%doc README.md COPYING
%dir %{_javadir}/%{name}
%{_javadir}/%{name}/*.jar
%attr(640, root, jboss) %config /etc/%{name}/*

%files jboss
%defattr(644, root, root, 755)
%dir %{_javadir}/%{name}/jboss.war
%{_javadir}/%{name}/jboss.war/*
%dir %{_javadir}/%{name}/jboss-conf
%{_javadir}/%{name}/jboss-conf/*
%{jboss_deployments}/*
%dir /var/log/%{name}/jboss
%attr(755, root, root) /usr/bin/ovirt-optimizer-jboss

# Initscripts
%{_unitdir}/ovirt-optimizer-jboss.service


%files ui
%defattr(644, root, root, 755)
%dir %{engine_data}/ui-plugins/ovirt-optimizer-resources
%config %{engine_etc}/ui-plugins/ovirt-optimizer-config.json
%{engine_data}/ui-plugins/ovirt-optimizer.json
%{engine_data}/ui-plugins/ovirt-optimizer-resources/*

%files dependencies
%defattr(644, root, root, 755)
%doc COPYING.csv
%dir %{_javadir}/%{name}/bundled
%{_javadir}/%{name}/bundled/*

%post jboss
# Systemd scripts
%systemd_post ovirt-optimizer-jboss.service

%changelog
* Mon Nov 21 2016 Martin Sivak <msivak@redhat.com> 0.14-2
- Add handling of SDKv4 errors
  Resolves: rhbz#1390252

* Tue Oct 25 2016 Martin Sivak <msivak@redhat.com> 0.13-1
- Fix UI plugin issues with the new v4 engine's REST api
  Resolves: rhbz#1388394

* Wed Oct 19 2016 Martin Sivak <msivak@redhat.com> 0.12-1
- Fix deserialization of optimize request
- Depend on Optaplanner's commons-lang3 jar

* Wed Sep 14 2016 Martin Sivak <msivak@redhat.com> 0.11-4
- Removed dependencies on xmvn and related packages to avoid
  depending on the optional channel

* Thu Jun  2 2016 Martin Sivak <msivak@redhat.com> 0.11-1
- Proper dependency on Optaplanner, no more archive downloads
- Java 8 requirement
- RHEL 7 requirement

* Mon Mar 23 2015 Martin Sivak <msivak@redhat.com> 0.7-1
- Add CSRF protection headers when accessing engine's REST
  Resolves: rhbz#1172978

- Ignore PinToHost rules when starting a new VM
  Resolves: rhbz#1173117

- Use proper the protocol to get jQuery for index.html
  Resolves: rhbz#1181969

* Thu Nov 20 2014 Martin Sivak <msivak@redhat.com> 0.4-5
- Improve UI logic of Optimize start and cancel buttons
  Resolves: rhbz#1140723

* Mon Nov 10 2014 Martin Sivak <msivak@redhat.com> 0.4-4
- Fix uuid matching rules for even distribution policies
  Resolves: rhbz#1156141

- Fix the way we collect cluster policy parameters
  Related: rhbz#1156141

- Fix the UI styling so it looks more like RHEV
  Resolves: rhbz#1162955

* Tue Oct 07 2014 Martin Sivak <msivak@redhat.com> 0.4-3
- Add missing xmlpull library
  Related rhbz#877209

* Tue Oct 07 2014 Martin Sivak <msivak@redhat.com> 0.4-2
- Separate bundled libraries to dependencies subpackage
  Related rhbz#877209

* Mon Sep 22 2014 Martin Sivak <msivak@redhat.com> 0.4-1
- Fixed REST endpoint urls in UI plugin
  Resolves rhbz#1140721

* Wed Sep 10 2014 Martin Sivak <msivak@redhat.com> 0.3-4
- Fix config file permissions
  Resolves: rhbz#1140127

* Tue Sep 04 2014 Martin Sivak <msivak@redhat.com> 0.3-3
- Fix file permissions
  Related: rhbz#877209

* Mon Sep 03 2014 Martin Sivak <msivak@redhat.com> 0.3-2
- Fix the path to RHEVM java sdk and http commons libs
  Related: rhbz#877209

* Mon Sep 03 2014 Martin Sivak <msivak@redhat.com> 0.3-1
Initial release for RHEV 3.5

